Option Explicit
  '
  ' CONSTANTS
  '
    '
    ' Global Constants for Stay On Top call
    '
      Global Const SWP_NOMOVE = 2
      Global Const SWP_NOSIZE = 1
      Global Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
      Global Const HWND_TOPMOST = -1
      Global Const HWND_NOTOPMOST = -2
    '
    ' System Menu Constants
    '
      Global Const MF_SEPARATOR = &H800
      Global Const MF_STRING = &H0
      Global Const MF_ENABLED = 0
      Global Const MF_BYCOMMAND = &H0
      Global Const MF_UNCHECKED = &H0
      Global Const MF_CHECKED = &H8
      Global Const MF_BYPOSITION = &H400
  
      Global Const SM_TOOLBOX = 1
      Global Const SM_PROP = 2
      Global Const SM_PROJECT = 3
      Global Const SM_BOXES = 4
      Global Const SM_ABOUT = 5
      
      Global Const SMT_TOOLBOX = "&Toolbox On Top"
      Global Const SMT_PROJECT = "&Project Box On Top"
      Global Const SMT_PROP = "P&roperties Box On Top"
      Global Const SMT_BOXES = "'&Boxes On Top' On Top"
      Global Const SMT_ABOUT = "&About 'Boxes On Top'..."
    '
    ' Windows Message Constants
    '
      Global Const WM_QUERYOPEN = &H13    'restore minimized window message
      Global Const WM_SYSCOMMAND = &H112  'system command message
  '
  ' API CALLS
  '
    '
    ' FindWindow API call to locate VB Tools
    '
      Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpCaption As Any) As Integer
    '
    ' SetWindowPos API call used to toggle window stay on top status
    '
      Declare Function SetWindowPos Lib "User" (ByVal h As Integer, ByVal hb As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal f As Integer) As Integer
    '
    ' System Menu API Declarations
    '
      '
      ' Append or Remove menu items
      '
        Declare Function AppendMenu Lib "USER" (ByVal hMenu As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpNewItem As Any) As Integer
        Declare Function RemoveMenu Lib "USER" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer) As Integer
      '
      ' Get System Menu handle
      '
        Declare Function GetSystemMenu Lib "USER" (ByVal hWnd As Integer, ByVal bRevert As Integer) As Integer
      '
      ' Get the state of and modify System Menu items. Used to check and
      ' uncheck menu items
      '
        Declare Function GetMenuState Lib "USER" (ByVal hMenu As Integer, ByVal wId As Integer, ByVal wFlags As Integer) As Integer
        Declare Function ModifyMenuBystring Lib "USER" Alias "ModifyMenu" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpString As String) As Integer

Sub CheckOnTop (iMenuItem As Integer, sMenuTitle As String, iStatus As Integer)
  '
  ' Place checkmark on or remove checkmark from specified menu item.
  '
  Dim iResult As Integer
  Dim hMenu As Integer
  hMenu = GetSystemMenu(frmMain.hWnd, False)
  If iStatus = MF_UNCHECKED Then
    iResult = ModifyMenuBystring(hMenu, iMenuItem + 5, MF_UNCHECKED Or MF_BYPOSITION, iMenuItem, sMenuTitle)
  Else
    iResult = ModifyMenuBystring(hMenu, iMenuItem + 5, MF_CHECKED Or MF_BYPOSITION, iMenuItem, sMenuTitle)
  End If
End Sub

Function GetHwnd (sWindowClass As String, sWindowName As String) As Integer
  '
  ' Retrieves a Window's hWnd value.
  ' Requires either Class name or Windows Titlebar Caption
  '
  If sWindowClass = "" And sWindowName <> "" Then
    GetHwnd = FindWindow(0&, sWindowName)
  ElseIf sWindowClass <> "" And sWindowName = "" Then
    GetHwnd = FindWindow(sWindowClass, 0&)
  ElseIf sWindowClass <> "" And sWindowName <> "" Then
    GetHwnd = FindWindow(sWindowClass, sWindowName)
  Else
    GetHwnd = 0
  End If
End Function

Function IsMenuChecked (iMenuItem As Integer) As Integer
  '
  '  See if System Menu Item is checked or not
  '
  Dim iResult As Integer
  Dim hMenu As Integer
  hMenu = GetSystemMenu(frmMain.hWnd, False)
  iResult = GetMenuState(hMenu, iMenuItem, MF_BYCOMMAND)
  If iResult = MF_CHECKED Then
    IsMenuChecked = True
  Else
    IsMenuChecked = False
  End If
End Function

Sub SetupDialogMenu (frm As Form)
  Dim hMenu As Integer
  Dim iResult As Integer
  hMenu = GetSystemMenu(frm.hWnd, 0)
  '
  ' Remove all but the MOVE and CLOSE options. Note that
  ' the min and max buttons are assumed to be set to
  ' false and the form's BorderStyle is assumed to be
  ' fixed double.
  '
  iResult = RemoveMenu(hMenu, 8, MF_BYPOSITION) 'Switch to
  iResult = RemoveMenu(hMenu, 7, MF_BYPOSITION) 'Separator
  iResult = RemoveMenu(hMenu, 5, MF_BYPOSITION) 'Separator
End Sub

Sub SysMenuBuild ()
  '
  ' Add Additional Menu Strings to System Menu
  '
  Dim hMenu As Integer
  Dim iResult As Integer
  hMenu = GetSystemMenu(frmMain.hWnd, False)
  iResult = AppendMenu(hMenu, MF_SEPARATOR, 0, "")
  iResult = AppendMenu(hMenu, MF_STRING, SM_TOOLBOX, SMT_TOOLBOX)
  iResult = AppendMenu(hMenu, MF_STRING, SM_PROP, SMT_PROP)
  iResult = AppendMenu(hMenu, MF_STRING, SM_PROJECT, SMT_PROJECT)
  iResult = AppendMenu(hMenu, MF_STRING, SM_BOXES, SMT_BOXES)
  iResult = AppendMenu(hMenu, MF_SEPARATOR, 0, "")
  iResult = AppendMenu(hMenu, MF_STRING, SM_ABOUT, SMT_ABOUT)
End Sub

Sub ToggleWindowStatus (wParam As Integer, sWinClass As String, sWinTitle As String, sMenuText As String)
  If IsMenuChecked(wParam) Then
    If WindowOnTop(sWinClass, sWinTitle, False) Then
      CheckOnTop wParam, sMenuText, MF_UNCHECKED
    End If
  Else
    If WindowOnTop(sWinClass, sWinTitle, True) Then
      CheckOnTop wParam, sMenuText, MF_CHECKED
    End If
  End If
End Sub

Function WindowOnTop (sWinClass As String, sWinTitle As String, iToggle As Integer) As Integer
  '
  ' Reports True if operation is successful, False if not.
  '
  Dim iResult As Integer
  Dim hWnd As Integer
  '
  ' Get Window handle
  '
  hWnd = GetHwnd(sWinClass, sWinTitle)
  '
  ' If Window is present, then toggle it
  '
  If hWnd <> 0 Then
    If iToggle Then
      iResult = SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
    Else
      iResult = SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, FLAGS)
    End If
    WindowOnTop = True
  Else
    WindowOnTop = False
  End If
End Function

