// Windows Progress Bar Control Test Program

#include <windows.h>
#include "progress.h"
#include "progtest.h"

extern "C" {
  long far pascal _export WndProc(HWND, UINT, WORD, LONG);
  int pascal WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
}

const TOTAL = 500;

long far pascal _export WndProc(HWND hwnd, UINT message, WORD wParam,
  LONG lParam)
{
  switch (message)
  {
    case WM_CREATE:
      return 0;
    case WM_COMMAND:
      switch (wParam)
      {
        case LOWER:
        {
          int n =
            SendDlgItemMessage(hwnd, PROGRESSBAR, PB_GETCOMPLETED, 0, 0L);
          n = n - 1;
          if (n < 0) n = TOTAL;
          SendDlgItemMessage(hwnd, PROGRESSBAR, PB_SETCOMPLETED, n, 0L);
          return 0;
        }
        case HIGHER:
        {
          int n =
            SendDlgItemMessage(hwnd, PROGRESSBAR, PB_GETCOMPLETED, 0, 0L);
          n = n + 1;
          if (n > TOTAL) n = 0;
          SendDlgItemMessage(hwnd, PROGRESSBAR, PB_SETCOMPLETED, n, 0L);
          return 0;
        }
      }
      break;
    case WM_CLOSE:
      DestroyWindow(hwnd);
      return 0;
    case WM_DESTROY:
      PostQuitMessage(0);
      return 0;
  }
  return DefDlgProc (hwnd, message, wParam, lParam);
}

#pragma argsused
int pascal WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
{
    HWND hwnd;
    MSG msg;

    if (!hPrevInstance)
    {
      WNDCLASS wndclass;
      wndclass.style = 0;
      wndclass.lpfnWndProc = (WNDPROC) WndProc;
      wndclass.cbClsExtra = 0;
      wndclass.cbWndExtra = DLGWINDOWEXTRA;
      wndclass.hInstance = hInstance;
      wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
      wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
      wndclass.hbrBackground = NULL;
      wndclass.lpszMenuName = NULL;
      wndclass.lpszClassName = "PROGRESSTEST";
      RegisterClass (&wndclass);
    }

    hwnd = CreateDialog(hInstance, "PROGRESSTEST", 0, NULL);
    SendDlgItemMessage(hwnd, PROGRESSBAR, PB_SETTOTAL, TOTAL, 0L);

    ShowWindow(hwnd, nCmdShow == SW_SHOWMAXIMIZED ? SW_SHOW : nCmdShow);
    UpdateWindow(hwnd);

    while (GetMessage(&msg, NULL, 0, 0))
      if (!IsDialogMessage (hwnd, &msg))
          DispatchMessage (&msg);

    return msg.wParam;
}


