Option Explicit

'
' These token codes were arbitrarily defined for this demo
'
' It should serve as an example of how you could define the
' token values in your program.
'
' Remember that programmer defined tokens must be >= NT_MAX_OPERATORS
'
Global Const TK_FUNCTION = 100
Global Const TK_PROCEDURE = 101
Global Const TK_BEGIN = 102
Global Const TK_END = 103
Global Const TK_OPEN = 104
Global Const TK_CLOSE = 105
Global Const TK_IF = 106
Global Const TK_THEN = 107
Global Const TK_ELSE = 108
Global Const TK_INPUT = 109
Global Const TK_PRINT = 110
Global Const TK_DIM = 111
Global Const TK_AS = 112
Global Const TK_STRING = 113
Global Const TK_INTEGER = 114
Global Const TK_FLOAT = 114
Global Const TK_MESSAGE = 115
Global Const TK_EXIT = 116

'
' Function to convert a token into a formatted hex string for
' the demonstration lister text box
'
' Also demonstrates the use of NT_CodeString()
'
Function HexToken (level As Integer, token As Integer, keyword As String) As String

    HexToken = Space$(level) & "[" & HexWord(token) & ":" & keyword & "]=" & NT_CodeString(token)

End Function

'
' Just a utility function to build a 4 character
' Hexi-Decimal string for the integer passed.
'
Function HexWord (value As Integer) As String
Dim tmp As String
Const zeroes = "0000"

    tmp = Hex$(value)

    If Len(tmp) < 4 Then

        tmp = Left$(zeroes, 4 - Len(tmp)) & tmp

    End If

    HexWord = tmp

End Function

