PROGRAM SoTSuite;  { String Object Test Suite }


USES

   WinCrt,
   Objects,
   StrObj;

TYPE
   TMenuRec = RECORD
      L  : CHAR;
      D  : ARRAY[0..40] OF CHAR;
      C  : INTEGER;
      P1 : CHAR;
      P2 : CHAR;
      P3 : CHAR;
      P4 : CHAR;
   END;
   TParamRec = RECORD
      CASE INTEGER OF
         1 : (S : ARRAY[0..200] OF CHAR);
         2 : (W : word);
         3 : (C : CHAR);
         4 : (L : LONGINT);
         5 : (Y : BYTE);
         6 : (B : BOOLEAN);
         7 : (E : EXTENDED);
         8 : (R : REAL);
         9 : (D : DOUBLE);
        10 : (I : INTEGER);
        11 : (P : LONGINT);
        12 : (T : STRING)
   END;

VAR

   TargetStr : PStringObject;
   ParamArray : ARRAY[1..4] OF TParamRec;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION GetParam(Idx : INTEGER; AType : CHAR) : BOOLEAN;
   BEGIN
      CASE AType OF
         'S' :
            BEGIN
               Writeln('Enter a string parameter ...');
               Write('= ');
               ParamArray[Idx].S[0] := #0;
               Readln(ParamArray[Idx].S);
            END;
         'C' :
            BEGIN
               Writeln('Enter a CHAR parameter ...');
               Write('= ');
               ParamArray[Idx].C := ' ';
               Readln(ParamArray[Idx].C);
            END;
         'W' :
            BEGIN
               Writeln('Enter a WORD parameter ...');
               Write('= ');
               ParamArray[Idx].W := 0;
               Readln(ParamArray[Idx].W);
            END;
         'L' :
            BEGIN
               Writeln('Enter a LONGINT parameter ...');
               Write('= ');
               ParamArray[Idx].L := 0;
               Readln(ParamArray[Idx].L);
            END;
         'Y' :
            BEGIN
               Writeln('Enter a BYTE parameter ...');
               Write('= ');
               ParamArray[Idx].Y := 0;
               Readln(ParamArray[Idx].Y);
            END;
         'B' :
            BEGIN
               Writeln('Enter a BOOLEAN parameter (0 or 1) ...');
               Write('= ');
               ParamArray[Idx].Y := 0;
               Readln(ParamArray[Idx].Y);
            END;
         'E' :
            BEGIN
               Writeln('Enter a EXTENDED parameter ...');
               Write('= ');
               ParamArray[Idx].E := 0;
               Readln(ParamArray[Idx].E);
            END;
         'R' :
            BEGIN
               Writeln('Enter a REAL parameter ...');
               Write('= ');
               ParamArray[Idx].R := 0;
               Readln(ParamArray[Idx].R);
            END;
         'D' :
            BEGIN
               Writeln('Enter a DOUBLE parameter ...');
               Write('= ');
               ParamArray[Idx].D := 0;
               Readln(ParamArray[Idx].D);
            END;
         'I' :
            BEGIN
               Writeln('Enter a INTEGER parameter ...');
               Write('= ');
               ParamArray[Idx].I := 0;
               Readln(ParamArray[Idx].I);
            END;
         'P' :
            BEGIN
               Writeln('Enter a POINTER (as LONGINT) parameter ...');
               Write('= ');
               ParamArray[Idx].P := 0;
               Readln(ParamArray[Idx].P);
            END;
         'T' :
            BEGIN
               Writeln('Enter a PASCAL STRING parameter ...');
               Write('= ');
               ParamArray[Idx].T := '';
               Readln(ParamArray[Idx].T);
            END;
      END
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoPCharTest : CHAR;
   CONST
      FTotal = 18;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'Append';C:1;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'Append2';C:2;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'AppendLen';C:2;P1:'S';P2:'W';P3:'S';P4:'S'),
          (L:'D';D:'AppendMid';C:3;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'E';D:'AppendNL';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'F';D:'AppendPad';C:3;P1:'S';P2:'W';P3:'C';P4:'S'),
          (L:'G';D:'AppendDIC';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'H';D:'AppendSIC';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'I';D:'AppendTrim';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'J';D:'Assign';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'K';D:'AssignAppend';C:2;P1:'S';P2:'S';P3:'W';P4:'S'),
          (L:'L';D:'AssignAppend2';C:3;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'M';D:'AssignLen';C:2;P1:'S';P2:'W';P3:'S';P4:'S'),
          (L:'N';D:'AssignMid';C:3;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'O';D:'AssignNL';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'P';D:'AssignPad';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'Q';D:'AssignTrim';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'R';D:'Prepend';C:1;P1:'S';P2:'W';P3:'W';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         MenuRec : TMenuRec;
         E : INTEGER;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         CASE SMSel OF
            'A' : TargetStr^.Append(ParamArray[1].S);
            'B' : TargetStr^.Append2(ParamArray[1].S,ParamArray[2].S);
            'C' : TargetStr^.AppendLen(ParamArray[1].S,ParamArray[2].W);
            'D' : TargetStr^.AppendMid(ParamArray[1].S,ParamArray[2].W,ParamArray[3].W);
            'E' : TargetStr^.AppendNL(ParamArray[1].S);
            'F' : TargetStr^.AppendPad(ParamArray[1].S,ParamArray[2].w,ParamArray[3].c);
            'G' : TargetStr^.AppendDIC(ParamArray[1].S);
            'H' : TargetStr^.AppendSIC(ParamArray[1].S);
            'I' : TargetStr^.AppendTrim(ParamArray[1].S);
            'J' : TargetStr^.Assign(ParamArray[1].S);
            'K' : TargetStr^.AssignAppend(ParamArray[1].S,ParamArray[2].S);
            'L' : TargetStr^.AssignAppend2(ParamArray[1].S,ParamArray[2].S,ParamArray[3].S);
            'M' : TargetStr^.AssignLen(ParamArray[1].S,ParamArray[2].W);
            'N' : TargetStr^.AssignMid(ParamArray[1].S,ParamArray[2].W,ParamArray[3].W);
            'O' : TargetStr^.AssignNL(ParamArray[1].S);
            'P' : TargetStr^.AssignPad(ParamArray[1].S,ParamArray[2].w,ParamArray[3].c);
            'Q' : TargetStr^.AssignTrim(ParamArray[1].S);
            'R' : TargetStr^.Prepend(ParamArray[1].S);
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      DoPCharTest := ' ';
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('PChar method test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('5. Goto Character menu');
         writeln('6. Goto DOS/Pathname menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '5' : SMSel := 'B';
               '6' : SMSel := 'E';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoPCharTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoCharTest : CHAR;
   CONST
      FTotal = 9;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'FirstCharIs';C:1;P1:'C';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'FirstNonSpaceChar';C:0;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'GetChar';C:1;P1:'W';P2:'W';P3:'S';P4:'S'),
          (L:'D';D:'HasCh';C:1;P1:'C';P2:'W';P3:'W';P4:'S'),
          (L:'E';D:'IsChar';C:2;P1:'W';P2:'C';P3:'W';P4:'S'),
          (L:'F';D:'LastCharIs';C:1;P1:'C';P2:'W';P3:'C';P4:'S'),
          (L:'G';D:'LastNonSpaceChar';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'H';D:'RemoveLastChar';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'I';D:'SetChar';C:2;P1:'W';P2:'C';P3:'W';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         MenuRec : TMenuRec;
         E : INTEGER;
         FB : BOOLEAN;
         FW : WORD;
         FC : CHAR;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         FB := TRUE;
         FW := 0;
         FC := ' ';
         CASE SMSel OF
            'A' : FB := TargetStr^.FirstCharIs(ParamArray[1].C);
            'B' : FW := TargetStr^.FirstNonSpaceChar(FC);
            'C' : FC := TargetStr^.GetChar(ParamArray[1].W);
            'D' : FB := TargetStr^.HasCh(ParamArray[1].C,FW);
            'E' : FB := TargetStr^.IsChar(ParamArray[1].W,ParamArray[2].C);
            'F' : FB := TargetStr^.LastCharIs(ParamArray[1].C);
            'G' : FW := TargetStr^.LastNonSpaceChar(FC);
            'H' : TargetStr^.RemoveLastChar;
            'I' : TargetStr^.SetChar(ParamArray[1].W,ParamArray[2].C);
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         IF FB THEN
            Writeln('Function Result = TRUE')
         ELSE
            Writeln('Function Result = FALSE');
         Writeln('Function WORD = ',FW);
         Writeln('Function CHAR = ',FC);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('Character level test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoCharTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoOtherTest : CHAR;
   CONST
      FTotal = 26;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'AppendByte';C:1;P1:'Y';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'AppendChar';C:1;P1:'C';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'AppendExt';C:3;P1:'E';P2:'Y';P3:'Y';P4:'S'),
          (L:'D';D:'AppendLong';C:1;P1:'L';P2:'W';P3:'W';P4:'S'),
          (L:'E';D:'AppendReal';C:3;P1:'R';P2:'Y';P3:'Y';P4:'S'),
          (L:'F';D:'FromDouble';C:2;P1:'S';P2:'D';P3:'C';P4:'S'),
          (L:'G';D:'FromBoolean';C:2;P1:'B';P2:'I';P3:'W';P4:'S'),
          (L:'H';D:'FromByte';C:1;P1:'Y';P2:'W';P3:'W';P4:'S'),
          (L:'I';D:'FromChar';C:1;P1:'C';P2:'C';P3:'W';P4:'S'),
          (L:'J';D:'FromExt';C:3;P1:'E';P2:'Y';P3:'Y';P4:'S'),
          (L:'K';D:'FromLong';C:1;P1:'L';P2:'S';P3:'S';P4:'S'),
          (L:'L';D:'FromPtr';C:1;P1:'P';P2:'W';P3:'S';P4:'S'),
          (L:'M';D:'FromReal';C:3;P1:'R';P2:'Y';P3:'Y';P4:'S'),
          (L:'N';D:'FromRGB';C:1;P1:'L';P2:'C';P3:'W';P4:'S'),
          (L:'O';D:'HexFromByte';C:1;P1:'Y';P2:'W';P3:'C';P4:'S'),
          (L:'P';D:'HexFromLong';C:1;P1:'L';P2:'W';P3:'W';P4:'S'),
          (L:'Q';D:'HexFromPtr';C:1;P1:'P';P2:'W';P3:'W';P4:'S'),
          (L:'R';D:'HexFromWord';C:1;P1:'W';P2:'C';P3:'W';P4:'S'),
          (L:'S';D:'ToBoolean';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'T';D:'ToByte';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'U';D:'ToChar';C:0;P1:'W';P2:'C';P3:'W';P4:'S'),
          (L:'V';D:'ToDouble';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'W';D:'ToExt';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'X';D:'ToLong';C:0;P1:'W';P2:'C';P3:'W';P4:'S'),
          (L:'Y';D:'ToReal';C:0;P1:'C';P2:'S';P3:'S';P4:'S'),
          (L:'Z';D:'ToRGB';C:0;P1:'S';P2:'S';P3:'S';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         MenuRec : TMenuRec;
         E : INTEGER;
         FB : BOOLEAN;
         FW : WORD;
         FC,VC : CHAR;
         VB : BOOLEAN;
         VY : BYTE;
         VL : LONGINT;
         VD : DOUBLE;
         VE : EXTENDED;
         VR : REAL;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         FB := TRUE;
         VY := 0;
         VB := TRUE;
         VL := 0;
         VR := 0;
         VD := 0;
         VE := 0;
         CASE SMSel OF
            'A' : TargetStr^.AppendByte(ParamArray[1].Y);
            'B' : TargetStr^.AppendChar(ParamArray[1].C);
            'C' : TargetStr^.AppendExt(ParamArray[1].E,ParamArray[2].Y,ParamArray[3].Y);
            'D' : TargetStr^.AppendLong(ParamArray[1].L);
            'E' : TargetStr^.AppendReal(ParamArray[1].R,ParamArray[2].Y,ParamArray[3].Y);
            'F' : TargetStr^.FromDouble(ParamArray[1].S,ParamArray[2].D);
            'G' : TargetStr^.FromBoolean(ParamArray[1].B,ParamArray[2].I);
            'H' : TargetStr^.FromByte(ParamArray[1].Y);
            'I' : TargetStr^.FromChar(ParamArray[1].C);
            'J' : TargetStr^.FromExt(ParamArray[1].E,ParamArray[2].Y,ParamArray[3].Y);
            'K' : TargetStr^.FromLong(ParamArray[1].L);
            'L' : TargetStr^.FromPtr(POINTER(ParamArray[1].P));
            'M' : TargetStr^.FromReal(ParamArray[1].R,ParamArray[2].Y,ParamArray[3].Y);
            'N' : TargetStr^.FromRGB(ParamArray[1].L);
            'O' : TargetStr^.HexFromByte(ParamArray[1].Y);
            'P' : TargetStr^.HexFromLong(ParamArray[1].L);
            'Q' : TargetStr^.HexFromPtr(POINTER(ParamArray[1].P));
            'R' : TargetStr^.HexFromWord(ParamArray[1].W);
            'S' : FB := TargetStr^.ToBoolean(VB);
            'T' : FB := TargetStr^.ToByte(VY);
            'U' : FB := TargetStr^.ToChar(VC);
            'V' : FB := TargetStr^.ToDouble(VD);
            'W' : FB := TargetStr^.ToExt(VE);
            'X' : FB := TargetStr^.ToLong(VL);
            'Y' : FB := TargetStr^.ToReal(VR);
            'Z' : FB := TargetStr^.ToRGB(VL);
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         IF FB THEN
            Writeln('Function Result = TRUE')
         ELSE
            Writeln('Function Result = FALSE');
         Writeln('Var Byte = ',VY, ' : Var Boolean = ',VB,' : Var Long = ',VL);
         Writeln('Var REAL = ',VR:10:4);
         Writeln('Var Double = ',VD:15:4,' : Var Ext = ',VE:15:4);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('Character level test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoOtherTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoStringsTest : CHAR;
   CONST
      FTotal = 19;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'StrCat';C:1;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'StrComp';C:1;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'StrCopy';C:1;P1:'S';P2:'Y';P3:'Y';P4:'S'),
          (L:'D';D:'StrECopy';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'E';D:'StrEnd';C:0;P1:'R';P2:'Y';P3:'Y';P4:'S'),
          (L:'F';D:'StrIComp';C:1;P1:'S';P2:'D';P3:'C';P4:'S'),
          (L:'G';D:'StrLCat';C:2;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'H';D:'StrLIComp';C:2;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'I';D:'StrLComp';C:2;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'J';D:'StrLCopy';C:2;P1:'S';P2:'W';P3:'Y';P4:'S'),
          (L:'K';D:'StrLen';C:0;P1:'L';P2:'S';P3:'S';P4:'S'),
          (L:'L';D:'StrLower';C:0;P1:'P';P2:'W';P3:'S';P4:'S'),
          (L:'M';D:'StrMove';C:2;P1:'S';P2:'W';P3:'Y';P4:'S'),
          (L:'N';D:'StrPas';C:0;P1:'L';P2:'C';P3:'W';P4:'S'),
          (L:'O';D:'StrPCopy';C:1;P1:'T';P2:'W';P3:'C';P4:'S'),
          (L:'P';D:'StrPos';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'Q';D:'StrRScan';C:1;P1:'C';P2:'W';P3:'W';P4:'S'),
          (L:'R';D:'StrScan';C:1;P1:'C';P2:'C';P3:'W';P4:'S'),
          (L:'S';D:'StrUpper';C:0;P1:'S';P2:'W';P3:'W';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         MenuRec : TMenuRec;
         E : INTEGER;
         FB : BOOLEAN;
         FW : WORD;
         FC,VC : CHAR;
         VB : BOOLEAN;
         VY : BYTE;
         VL : LONGINT;
         FI : INTEGER;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         FB := TRUE;
         FI := 0;
         FW := 0;
         CASE SMSel OF
            'A' : TargetStr^.StrCat(ParamArray[1].S);
            'B' : FI := TargetStr^.StrComp(ParamArray[1].S);
            'C' : TargetStr^.StrCopy(ParamArray[1].S);
            'D' : TargetStr^.StrECopy(ParamArray[1].S);
            'E' : FW := TargetStr^.StrEnd - TargetStr^.GetPChar;
            'F' : FI := TargetStr^.StrIComp(ParamArray[1].S);
            'G' : TargetStr^.StrLCat(ParamArray[1].S,ParamArray[2].W);
            'H' : FI := TargetStr^.StrLIComp(ParamArray[1].S,ParamArray[2].W);
            'I' : FI := TargetStr^.StrLComp(ParamArray[1].S,ParamArray[2].W);
            'J' : TargetStr^.StrLCopy(ParamArray[1].S,ParamArray[2].W);
            'K' : FW := TargetStr^.StrLen;
            'L' : TargetStr^.StrLower;
            'M' : TargetStr^.StrMove(ParamArray[1].S,ParamArray[2].W);
            'N' : TargetStr^.StrPas;
            'O' : TargetStr^.StrPCopy(ParamArray[1].T);
            'P' : FW := TargetStr^.StrPos(ParamArray[1].S) - TargetStr^.GetPChar;
            'Q' : FW := TargetStr^.StrRScan(ParamArray[1].C) - TargetStr^.GetPChar;
            'R' : FW := TargetStr^.StrScan(ParamArray[1].C) - TargetStr^.GetPChar;
            'S' : TargetStr^.StrUpper;
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         IF FB THEN
            Writeln('Function Result = TRUE')
         ELSE
            Writeln('Function Result = FALSE');
         Writeln('Function Word Result = ',FW,' : Integer Result = ',FI);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('Character level test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoStringsTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoDosTest : CHAR;
   CONST
      FTotal = 14;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'AddBackSlash';C:0;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'BuildPathName';C:3;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'DefaultExtension';C:1;P1:'S';P2:'W';P3:'S';P4:'S'),
          (L:'D';D:'ForceExtension';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'E';D:'HasBackSlash';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'F';D:'HasDrive';C:0;P1:'S';P2:'W';P3:'C';P4:'S'),
          (L:'G';D:'HasDirectory';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'H';D:'DirectoryExists';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'I';D:'DriveExists';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'J';D:'FileExists';C:0;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'K';D:'JustExtension';C:1;P1:'S';P2:'S';P3:'W';P4:'S'),
          (L:'L';D:'JustFileName';C:1;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'M';D:'JustDirectory';C:1;P1:'S';P2:'W';P3:'S';P4:'S'),
          (L:'N';D:'SetCurDir';C:0;P1:'S';P2:'W';P3:'W';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         MenuRec : TMenuRec;
         E : INTEGER;
         FB : BOOLEAN;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         FB := TRUE;
         CASE SMSel OF
            'A' : TargetStr^.AddBackSlash;
            'B' : TargetStr^.BuildPathname(ParamArray[1].S,ParamArray[2].S,ParamArray[3].S);
            'C' : TargetStr^.DefaultExtension(ParamArray[1].S);
            'D' : TargetStr^.ForceExtension(ParamArray[1].S);
            'E' : FB := TargetStr^.HasBackSlash;
            'F' : FB := TargetStr^.HasDrive;
            'G' : FB := TargetStr^.HasDirectory;
            'H' : FB := TargetStr^.DirectoryExists;
            'I' : FB := TargetStr^.DriveExists;
            'J' : FB := TargetStr^.FileExists;
            'K' : TargetStr^.JustExtension(ParamArray[1].S);
            'L' : TargetStr^.JustFileName(ParamArray[1].S);
            'M' : TargetStr^.JustDirectory(ParamArray[1].S);
            'N' : FB := TargetStr^.SetCurDir;
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         IF FB THEN
            Writeln('Function Result = TRUE')
         ELSE
            Writeln('Function Result = FALSE');
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      DoDosTest := ' ';
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('DOS/PathName method test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoDosTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoSearchTest : CHAR;
   CONST
      FTotal = 10;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'ChCount';C:1;P1:'C';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'FindFirst';C:1;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'FindFirstCh';C:1;P1:'C';P2:'W';P3:'S';P4:'S'),
          (L:'D';D:'FindLast';C:1;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'E';D:'FindLastCh';C:1;P1:'C';P2:'W';P3:'W';P4:'S'),
          (L:'F';D:'FindNext';C:2;P1:'S';P2:'W';P3:'C';P4:'S'),
          (L:'G';D:'FindNextCh';C:2;P1:'C';P2:'W';P3:'W';P4:'S'),
          (L:'H';D:'FindPrev';C:2;P1:'S';P2:'W';P3:'W';P4:'S'),
          (L:'I';D:'FindPrevCh';C:2;P1:'C';P2:'W';P3:'W';P4:'S'),
          (L:'J';D:'SubStrCount';C:1;P1:'S';P2:'W';P3:'W';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         E : INTEGER;
         FB : BOOLEAN;
         FW,VW : WORD;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         FB := TRUE;
         FW := 0;
         VW := 0;
         CASE SMSel OF
            'A' : FW := TargetStr^.ChCount(ParamArray[1].C);
            'B' : FB := TargetStr^.FindFirst(ParamArray[1].S,VW);
            'C' : FB := TargetStr^.FindFirstCh(ParamArray[1].C,VW);
            'D' : FB := TargetStr^.FindLast(ParamArray[1].S,VW);
            'E' : FB := TargetStr^.FindLastCh(ParamArray[1].C,VW);
            'F' : FB := TargetStr^.FindNext(ParamArray[1].S,ParamArray[1].W,VW);
            'G' : FB := TargetStr^.FindNextCh(ParamArray[1].C,ParamArray[1].W,VW);
            'H' : FB := TargetStr^.FindPrev(ParamArray[1].S,ParamArray[1].W,VW);
            'I' : FB := TargetStr^.FindPrevCh(ParamArray[1].C,ParamArray[1].W,VW);
            'J' : FW := TargetStr^.SubStrCount(ParamArray[1].S);
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         IF FB THEN
            Writeln('Function Result = TRUE')
         ELSE
            Writeln('Function Result = FALSE');
         Writeln('Word function result = ',FW,' : Var Word = ',VW);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('Search method test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoSearchTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoCaseTest : CHAR;
   CONST
      FTotal = 3;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'FirstCharToUpper';C:0;P1:'C';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'ToLower';C:0;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'ToUpper';C:0;P1:'C';P2:'W';P3:'S';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         E : INTEGER;
         FB : BOOLEAN;
         FW,VW : WORD;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         CASE SMSel OF
            'A' : TargetStr^.FirstCharToUpper;
            'B' : TargetStr^.ToLower;
            'C' : TargetStr^.ToUpper;
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('Case method test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoCaseTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoReplaceTest : CHAR;
   CONST
      FTotal = 6;
      MenuArray : ARRAY[1..FTotal] OF TMenuRec =
         (
          (L:'A';D:'ReplaceAll';C:2;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'B';D:'ReplaceFirst';C:2;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'C';D:'ReplaceLast';C:2;P1:'S';P2:'S';P3:'S';P4:'S'),
          (L:'D';D:'ReplaceChAll';C:2;P1:'C';P2:'C';P3:'W';P4:'S'),
          (L:'E';D:'ReplaceChFirst';C:2;P1:'C';P2:'C';P3:'W';P4:'S'),
          (L:'F';D:'ReplaceChLast';C:2;P1:'C';P2:'C';P3:'C';P4:'S')
         );
   VAR
      IStr : PStringObject;
      SMSel : CHAR;
      E : INTEGER;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoTest;
      var
         RNO : INTEGER;
         E : INTEGER;
         FB : BOOLEAN;
         FW,VW : WORD;
      BEGIN
         { get record number from menu selection }
         RNo := ORD(SMSel)-64;
         { get params }
         IF MenuArray[RNo].C > 0 THEN
         BEGIN
            Writeln('Test on method : ',MenuArray[RNo].D);
            FOR E := 1 TO MenuArray[RNo].C DO
            BEGIN
               CASE E OF
                  1 : GetParam(E,MenuArray[RNo].P1);
                  2 : GetParam(E,MenuArray[RNo].P2);
                  3 : GetParam(E,MenuArray[RNo].P3);
                  4 : GetParam(E,MenuArray[RNo].P4);
               END
            END
         END;
         { test function }
         Writeln('Test on method : ',MenuArray[RNo].D);
         Writeln('Target string value BEFORE test ...');
         Writeln(TargetStr^.GetPChar);
         FB := TRUE;
         FW := 0;
         VW := 0;
         CASE SMSel OF
            'A' : TargetStr^.ReplaceAll(ParamArray[1].S,ParamArray[2].S);
            'B' : TargetStr^.ReplaceFirst(ParamArray[1].S,ParamArray[2].S);
            'C' : TargetStr^.ReplaceLast(ParamArray[1].S,ParamArray[2].S);
            'D' : TargetStr^.ReplaceChAll(ParamArray[1].C,ParamArray[2].C);
            'E' : TargetStr^.ReplaceChFirst(ParamArray[1].C,ParamArray[2].C);
            'F' : TargetStr^.ReplaceChLast(ParamArray[1].C,ParamArray[2].C);
         END;
         Writeln('Target string value AFTER test ...');
         Writeln(TargetStr^.GetPChar);
         Writeln('Hit the ENTER key to continue ...');
         readln;
      END;

      { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      IStr := NEW(PStringObject,InitDefault);
      REPEAT
         CLRSCR;
         Writeln('Search & Replace method test menu');
         writeln;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         FOR E := 1 TO FTotal DO
         BEGIN
            IF (E MOD 2) = 1 THEN
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               IStr^.PadEnd(30,' ');
               Write(IStr^.GetPChar);
            END
            ELSE
            BEGIN
               IStr^.FromChar(MenuArray[E].L);
               IStr^.Append2('. ',MenuArray[E].D);
               Writeln(IStr^.GetPChar);
            END
         END;
         writeln;
         writeln('6. Goto PChar menu');
         writeln('7. Clear target string object to NIL');
         writeln('8. Return to Main Menu');
         writeln('9. Quit');
         writeln;
         write('Enter menu selection ===> ');
         Readln(SMSel);
         SMSel := UPCASE(SMSel);
         IF (SMSel >= 'A') AND (SMSel <= 'Z') THEN
         BEGIN
            DoTest;
            SMSel := ' ';
         END
         ELSE
         BEGIN
            CASE SMSel OF
               '6' : SMSel := 'A';
               '7' :
                  BEGIN
                     TargetStr^.Assign(NIL);
                     SMSel := ' ';
                  END;
            END
         END;
      UNTIL SMSel <> ' ';
      DISPOSE(IStr,Done);
      DoReplaceTest := SMSel;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION DoParseTest: CHAR;
   VAR
      Source : ARRAY[0..200] OF CHAR;
      DelimCh : CHAR;
      AList : PCollection;
      Idx : INTEGER;
      TempObj : PStringObject;

      { +++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE DoStrObj(S : PStringObject); FAR;
      BEGIN
         IF S^.GetLength = 0 THEN
            Writeln(Idx : 4, ' : <NULL>')
         ELSE
            Writeln(Idx : 4, ' : ',S^.GetPChar);
         INC(Idx);
      END;

      { +++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      Writeln('String Parsing test');
      writeln;
      Writeln('Enter a source string to parse ...');
      Write('= ');
      Readln(Source);
      Writeln('Enter the delimiter character ...');
      Write('= ');
      Readln(DelimCh);
      TempObj := NEW(PStringObject,Init(Source));
      AList := NIL;
      TempObj^.ParseDelimToList(DelimCh,delim_None,AList);
      Writeln;
      Idx := 1;
      AList^.ForEach(@DoStrObj);
      Writeln;
      DISPOSE(AList,Done);
      DISPOSE(TempObj,Done);
      Writeln('Hit the ENTER key to continue ....');
      Readln;
      DoParseTest := '8'
   END;


   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoMainMenu;
   VAR
      MMStr : PStringObject;
      MMSel : CHAR;
   BEGIN
      TargetStr := NEW(PStringObject,InitDefault);
      MMStr := NEW(PStringObject,InitNL('TStringObject Test Suite'));
      MMStr^.AppendNL(NIL);
      MMStr^.AppendNL('A. Test PChar method.');
      MMStr^.AppendNL('B. Test Character level method.');
      MMStr^.AppendNL('C. Test Other Data Type conversion method.');
      MMStr^.AppendNL('D. Test STRINGS unit function method.');
      MMStr^.AppendNL('E. Test DOS pathname method.');
      MMStr^.AppendNL('F. Test search method.');
      MMStr^.AppendNL('G. Test case method.');
      MMStr^.AppendNL('H. Test search and replace method.');
      MMStr^.AppendNL('I. Test parsing method.');
      MMStr^.AppendNL('J. Clear working string object.');
      MMStr^.AppendNL('9. End this test suite application.');
      MMStr^.AppendNL(NIL);
      MMStr^.Append('Select a menu item ===> ');
      REPEAT
         CLRSCR;
         IF TargetStr^.Getlength = 0 THEN
            Writeln('Current target string = NIL')
         ELSE
            Writeln('Current target string = ',TargetStr^.GetPChar);
         Writeln;
         Write(MMStr^.GetPChar);
         Readln(MMSel);
         MMSel := UPCASE(MMSel);
         REPEAT
            CASE MMSel OF
               'A' : MMSel := DoPCharTest;
               'B' : MMSel := DoCharTest;
               'C' : MMSel := DoOtherTest;
               'D' : MMSel := DoStringsTest;
               'E' : MMSel := DoDosTest;
               'F' : MMSel := DoSearchTest;
               'G' : MMSel := DoCaseTest;
               'H' : MMSel := DoReplaceTest;
               'I' : MMSel := DoParseTest;
               'J' : TargetStr^.Assign(NIL);
            END;
         UNTIL MMSel < 'A';
      UNTIL MMSel = '9';
      DISPOSE(MMStr,Done);
      DISPOSE(TargetStr,Done);
   END;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

BEGIN

   InitWinCrt;

   DoMainMenu;

   DoneWinCrt;

END.