VERSION 2.00
Begin Form Terp 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Interpreted Code"
   ClientHeight    =   4800
   ClientLeft      =   645
   ClientTop       =   2070
   ClientWidth     =   7890
   ControlBox      =   0   'False
   Height          =   5175
   Left            =   600
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   540
   ScaleWidth      =   540
   Top             =   1740
   Width           =   7980
   Begin CommandButton biExit 
      Caption         =   "&Exit"
      Height          =   345
      Left            =   100
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   120
      Width           =   675
   End
   Begin TextBox Lister 
      BackColor       =   &H00808000&
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "Fixedsys"
      FontSize        =   9
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   4185
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Tag             =   "OL"
      Top             =   540
      Width           =   7365
   End
End
Option Explicit

'
' This subroutine places the text in <txt> into the Lister text box
'
Sub Add2List (txt As String)

    Lister = Lister & txt & Chr$(13) & Chr$(10)

End Sub

Sub biExit_Click ()

    Unload Me

End Sub

'
' Sample code for decoding a variable type
'
Function DecodeType (token As Integer) As Integer

    Select Case token

        Case TK_STRING
        '
        ' "STRING" keyword
        '
            DecodeType = VTSTRING
        
        Case TK_INTEGER
        '
        ' "INTEGER" keyword
        '
            DecodeType = VTINTEGER
        
        Case TK_FLOAT
        '
        ' "FLOAT" keyword
        '
            DecodeType = VTFLOAT
        
        Case Else
            DecodeType = -1

    End Select

End Function

'
' Sample of what variable definition code might look like
'
' This demonstration example is, however, quite functional
'
' Note: the subroutine Add2List is used to add text to the Lister text box
'
Function DimVariable (ii As Integer, ByVal buf As String) As Integer

Dim keyword As String * AKW_MAX_KEYWORD_LEN     ' keyword buffer
Dim varname As String                           ' variable name buffer
Dim token   As Integer                          ' token value
Dim rc      As Integer                          ' return code
                
    DimVariable = False
    
    ' collect next keyword
    ' this will normally be the variable name

    keyword = NextToken(ii, buf, token)

    ' NextToken checks the keyword against known keywords to
    ' avoid duplicate declarations

    If token = NT_TOKEN_NOTFOUND Then ' it's likely to be unique

        ' collect the variable name
        
        varname = keyword
        
        Add2List HexToken(1, token, varname)

        ' now look for the AS keyword
        keyword = NextToken(ii, buf, token)
                    
        If token = TK_AS Then

            ' report the AS token
            Add2List HexToken(1, token, keyword)
                        
            ' get the type
            
            keyword = NextToken(ii, buf, token)
            Add2List HexToken(1, token, keyword)
                        
            ' set rc to variable type code based on current token
            '
            rc = DecodeType(token)

            '
            ' if successful, then report the details
            '
            If rc > -1 Then

                ' initialize variable to <empty>

                Select Case rc
                    
                    Case VTINTEGER, VTFLOAT
                    '
                    ' set numbers = 0
                    '
                        rc = AddVariable(Trim(varname), rc, "0")

                    Case Else
                    '
                    ' strings (etc) = ""
                    '
                        rc = AddVariable(Trim(varname), rc, "")

                End Select

                Add2List " --> " & Trim(varname) & " as " & Trim(keyword)
                DimVariable = True

            Else
            '
            ' Invalid data type (not "STRING", "INTEGER" or "FLOAT")
            '
                Add2List " --> [Invalid Data Type]"

            End If


        Else
        '
        ' Expected the "AS" token
        '
            Add2List HexToken(1, token, keyword) & " [Expected '" & GetTokenKeyword(TK_AS) & "'] "

        End If

    Else
    '
    ' The token found is not a candidate for a variable
    '
        Add2List " --> " & Trim(keyword) & " [Invalid Identifier] " & NT_CodeString(token)

    End If

End Function

'
' This function is an example of variable equating
'
' Though limited, the code demonstrates the process
' required for interpreting variable equating code
'
Function EquateVariable (ii As Integer, varname As String, ByVal buf As String) As Integer

Dim keyword As String * AKW_MAX_KEYWORD_LEN
Dim varval  As String   ' variable value as a string
Dim strval  As String   ' string variable value
Dim token   As Integer
Dim vtype   As Integer  ' variable type
Dim rc      As Integer  ' return code

    ' assume failure

    EquateVariable = False

    keyword = NextToken(ii, buf, token)

    Add2List HexToken(1, token, keyword)

    '
    '  This line includes an example of how to use NT_Operators
    '
    If Not (token = InStr(NT_Operators(), "=")) Then
        
        '
        '  Syntax error: Expected "="
        '
        Add2List "Syntax Error: Expected '='"
        ii = -1

    Else

        ' collect literal or variable
        keyword = NextToken(ii, buf, token)
        
        Add2List HexToken(1, token, keyword)
        
        Select Case token

            Case NT_TOKEN_NOTFOUND
            '
            ' If the next keyword is not a token, then it is
            ' either a number (strings usually start with the operator " or ')
            ' or an error
            '
                If ValidNumber(Trim(keyword)) Then
                '
                ' determine whether a float (contains a ".") or
                ' an integer
                '
                    If InStr(keyword, ".") > 0 Then ' floating point number

                        vtype = VTFLOAT

                    Else

                        vtype = VTINTEGER

                    End If

                    ' rc set to variable type
                    ' varval set to current variable contents

                    varval = GetVariable(varname, rc)


                    If rc = vtype Then
                    '
                    ' here is where you would use SetVariable()
                    ' to set the value to Keyword
                    '

                        rc = SetVariable(varname, Trim$(keyword))

                        Add2List " --> Variable '" & varname & "' was " & varval
                        Add2List " --> Variable '" & varname & "' now " & GetVariable(varname, vtype)
                    
                        EquateVariable = True

                    Else

                        Add2List " --> Type Mismatch Error!"

                    End If

                Else

                    Add2List "Invalid numeric constant. [" & keyword & "]"

                End If

            Case NT_VARIABLE_FOUND                              ' a variable
            '
            ' In this case, the right side of the equation is a variable
            '
            ' I won't go into that here, but you would need to determine if
            ' the variable types are compatible.  If the "variable" is a function
            ' or procedure, then you would have to implement code to translate
            ' or execute the function.
            '

            Case NT_DBL_QUOTE, NT_SNG_QUOTE ' a literal string
            '
            ' In this case, the right side of the equation is the first
            ' operator of a string literal.
            '
            ' I won't go into it here, but you would likely use a ParseStr() call
            ' with delimiters of ", ', chr(13) and chr(10).  These delimiters would
            ' parse to the next " or ' or to the end of the line.  Extra code would
            ' be required to implement imbedded single or double quotes.
            '
                If token = NT_DBL_QUOTE Then
                    
                    ' parse to next " or End of Line
                    strval = ParseStr(ii, buf, """" & Chr(13) & Chr(10))

                    '
                    ' In this case, it is necessary to increment
                    ' ii (the parsing index) by 1. This is due to the
                    ' fact that ParseStr() will stop at the next quote.
                    ' We need to skip by it to continue normally.
                    '
                    ii = ii + 1

                Else

                    ' parse to next ' or End of Line
                    strval = ParseStr(ii, buf, "'" & Chr(13) & Chr(10))
                    ii = ii + 1

                End If

                ' rc set to variable type
                ' varval set to current variable contents

                varval = GetVariable(varname, rc)

                '
                ' We have now safely parsed the value, but is the variable
                ' capable of this data?
                '
                If rc <> VTSTRING Then

                    Add2List " --> Type Mismatch Error!"

                Else

                    rc = SetVariable(varname, strval)

                    Add2List " --> Variable '" & varname & "' was """ & varval & """"
                    Add2List " --> Variable '" & varname & "' now """ & GetVariable(varname, vtype) & """"
                    
                    EquateVariable = True

                End If

        End Select
        
    End If

End Function

Sub Form_Load ()

    Interp  ' subroutine in this form

End Sub

Sub Form_Paint ()

    Outlines Me

End Sub

Sub Form_Resize ()

    On Error Resume Next

    Lister.Top = biExit.Top + biExit.Height + 120
    Lister.Left = 120
    Lister.Width = ScaleWidth - 240
    Lister.Height = ScaleHeight - Lister.Top - 120

End Sub

'
' The test interpreter
'
'   Note:   The procedure Add2List is used to place a formatted line
'           into the test display window. See Add2List for more info.
'
'   Also, this example does not buffer lines of the script. When implementing
'   code that supports Goto and Gosub, While and Loop constructs, it may
'   be best to buffer individual lines in a list.  Then the process of continuing
'   execution at another line would a matter of locating the line and continuing there.
'   However, this can be accomplished by pre-scanning the source and identifying
'   labels and their relative offset from the beginning of the code.
'
'   VBossAPI supports the LABEL data type.  This could be used to store the
'   character index value of the text immediately following the label.
'
'   I use this method to implement control loops, such as FOR..NEXT and DO..LOOP
'
Sub Interp ()

Dim prog    As String   ' the 'program'
Dim ii      As Integer  ' iterator index
Dim rc      As Integer  ' return code
Dim token   As Integer  ' token
Dim keyword As String * AKW_MAX_KEYWORD_LEN ' keyword buffer
Dim varname As String * AKW_MAX_KEYWORD_LEN ' variable name buffer

    ' get a copy of the editor text
    prog = Sampler.Editor.Text
    
    ' reset the NetToken index
    ii = 0
    
    ' clear are variable before running a the program (again).
    ZapVariables

    Do While ii > -1

        keyword = NextToken(ii, prog, token)
        
        Select Case token

            Case TK_DIM
            '
            '  DIM <var> AS <vartype> construct
            '
                
                Add2List HexToken(0, token, keyword)
                
                ' call the variable declaration code
                If Not DimVariable(ii, prog) Then

                    ' report error
                    Add2List "Execution Error: Program Cancelled."
                    
                    ' force cancellation
                    ii = -1

                End If

            Case NT_VARIABLE_FOUND
            '
            ' This line begins with a variable, so attempt
            ' to set the variable value (ie: [LET] <var> = <var>|<const>|<function())
            '
                Add2List HexToken(0, token, keyword)

                rc = EquateVariable(ii, Trim$(keyword), prog)
                
                '
                '  error recovery code could be placed here if rc = false
                '

            Case NT_PAST_EOL

                Add2List HexToken(0, token, keyword) & " [End of Program.]"

            '
            ' Many more cases would be placed here.  One for every construct
            ' you have defined.
            '
            ' Note: if any token or keyword is located in this loop that
            ' is not defined as the first token, you would want to implement
            ' a syntax error. Use Case Else to trap unexpected tokens.
            '
            ' I have left that code out of here for demonstration purposes
            '
            Case Else

                Add2List HexToken(0, token, keyword) & " [Unexpected Token/Keyword]"

        End Select

    Loop

End Sub

Sub Lister_KeyPress (KeyAscii As Integer)

    ' don't allow editing  in the interpreter listing text box

    KeyAscii = 0

End Sub

'
' Sample code to determine if the keyword passed
' is a valid number
'
Function ValidNumber (st As String) As Integer
Dim ii As Integer

    ValidNumber = True  ' assume so
    
    If Len(st) > 0 Then

        '
        '  scan the entire string
        '
        For ii = 1 To Len(st)

            '
            ' error exit if a character found that you
            ' do not concider part of a number
            '
            ' In this example I have used simple assumtions of
            ' what a number is.  You might include E or e
            '
            ' Keep in mind that a "-" sign is a operator.
            ' If a negative number is found, it would be preceded
            ' by the token for the "-" character.
            '
            If InStr("0123456789.", Mid$(st, ii, 1)) = 0 Then

                ValidNumber = False
                Exit Function

            End If

        Next

    End If

End Function

